extern "C" {
#include "stdio.h"
}

#include <string>
#include <new>

#define __THROW_BAD_ALLOC throw new std::bad_alloc();

class Socket {
private:
  void *d;
  Socket(void *);

public:
  Socket(int version=22);
  ~Socket();

  bool Open();
  void Close();
  std::string GetPeerIdentity();
  bool SetLog(FILE *f);
  bool Connect(std::string hostname, int port);
  bool Bind(int port, int backlog);
  Socket *Accept();
  bool Upgrade();
  bool Send(std::string message);
  bool SendUpdate();
  bool Receive(std::string &message);
  void SetHost(std::string);
};
